$regfile = "m8def.dat"
$crystal = 8000000
$hwstack = 100
$swstack = 100
$framesize = 100


St_a Alias Portb.0
Config St_a = Output
Reset St_a

St_b Alias Portd.7
Config St_b = Output
Reset St_b

St_c Alias Portd.6
Config St_c = Output
Reset St_c


St_d Alias Portd.5
Config St_d = Output
Reset St_d


Macro Stop_stepper
   Reset St_a
   Reset St_b
   Reset St_c
   Reset St_d
End Macro


Macro Step_1
   Set St_a
   Reset St_b
   Reset St_c
   Set St_d
End Macro


Macro Step_2
   Set St_a
   Reset St_b
   Reset St_c
   Reset St_d
End Macro


Macro Step_3
   Set St_a
   Reset St_b
   Set St_c
   Reset St_d
End Macro


Macro Step_4
   Reset St_a
   Reset St_b
   Set St_c
   Reset St_d
End Macro


Macro Step_5
   Reset St_a
   Set St_b
   Set St_c
   Reset St_d
End Macro


Macro Step_6
   Reset St_a
   Set St_b
   Reset St_c
   Reset St_d
End Macro


Macro Step_7
   Reset St_a
   Set St_b
   Reset St_c
   Set St_d
End Macro


Macro Step_8
   Reset St_a
   Reset St_b
   Reset St_c
   Set St_d
End Macro


Const Stepper_quant = 1
Const Timer_preset = 2

Dim Ticker_value(stepper_quant) As Word
Dim Max_wait_ticks(stepper_quant) As Word
Dim Current_step(stepper_quant) As Byte
Dim Direction(stepper_quant) As Byte
Dim Bt As Byte
Dim _bt As Byte


'8000000 / 1024 / 2 = 3906 berlufe die Sekunde
Config Timer0 = Timer , Prescale = 1024
On Timer0 On_timer0
Enable Timer0
Enable Interrupts


'Maximale Geschwindigkeit = 4
'Minimale Geschwindigkeit = 300

Max_wait_ticks(1) = 4
Direction(1) = 0


Dim Tmp As Word


Do

   'von schnell nach langsam
   For Tmp = 4 To 300
      Max_wait_ticks(1) = Tmp
      Waitms 70
   Next Tmp

   'von langsam nach schnell
   For Tmp = 300 To 4 Step -1
      Max_wait_ticks(1) = Tmp
      Waitms 70
   Next Tmp

   'Exit
   Max_wait_ticks(1) = 0
   Exit Do

Loop

End


On_timer0:
   'Timer so setzen, dass der berlauf nach <Timer_preset> Ticks wieder auftritt
   Load Timer0 , Timer_preset

   'Jeden Schrittmotor durchlaufen
   For _bt = 1 To Stepper_quant

      If Max_wait_ticks(_bt) > 0 Then
         'Ticker erhhen und prfen ob der nchste Schritt durchgefhrt
         'werden soll
         Incr Ticker_value(_bt)
         If Ticker_value(_bt) >= Max_wait_ticks(_bt) Then

            Ticker_value(_bt) = 0

            'Nchsten Schritt festlegen
            If Direction(_bt) = 0 Then
               Incr Current_step(_bt)
               If Current_step(_bt) > 8 Then
                  Current_step(_bt) = 1
               End If
            Else
               Decr Current_step(_bt)
               If Current_step(_bt) < 1 Then
                  Current_step(_bt) = 8
               End If
            End If

            'Nchsten Schritt ausfhren
            Select Case Current_step(_bt)
            Case 1 : Step_1
            Case 2 : Step_2
            Case 3 : Step_3
            Case 4 : Step_4
            Case 5 : Step_5
            Case 6 : Step_6
            Case 7 : Step_7
            Case 8 : Step_8
            End Select
         End If
      Else
         'Schrittmotor stoppen
         Ticker_value(_bt) = 0
         Stop_stepper
      End If

   Next _Bt

Return





